diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index f08380d..f0467c8 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -2920,33 +3375,36 @@ static void arcmsr_get_hbb_config(struct AdapterControlBlock *acb)
 	if(!arcmsr_hbb_wait_msgint_ready(acb)) {
 		kprintf( "arcmsr%d: wait" "'get adapter firmware miscellaneous data' timeout \n", acb->pci_unit);
 	}
-	i=0;
-	while(i<8) {
-		*acb_firm_model=bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_firm_model+i);
+	i = 0;
+	while(i < 8) {
+		*acb_firm_model = bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_firm_model+i);
 		/* 8 bytes firm_model, 15, 60-67*/
 		acb_firm_model++;
 		i++;
 	}
-	i=0;
-	while(i<16) {
-		*acb_firm_version=bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_firm_version+i);
+	i = 0;
+	while(i < 16) {
+		*acb_firm_version = bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_firm_version+i);
 		/* 16 bytes firm_version, 17, 68-83*/
 		acb_firm_version++;
 		i++;
 	}
-	i=0;
-	while(i<16) {
-		*acb_device_map=bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_device_map+i);
+	i = 0;
+	while(i < 16) {
+		*acb_device_map = bus_space_read_1(acb->btag[1], acb->bhandle[1], iop_device_map+i);  
 		acb_device_map++;
 		i++;
 	}
-	kprintf("ARECA RAID ADAPTER%d: %s \n", acb->pci_unit, ARCMSR_DRIVER_VERSION);
-	kprintf("ARECA RAID ADAPTER%d: FIRMWARE VERSION %s \n", acb->pci_unit, acb->firm_version);
-	acb->firm_request_len=CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[1]);   /*firm_request_len, 1, 04-07*/
-	acb->firm_numbers_queue=CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[2]); /*firm_numbers_queue, 2, 08-11*/
-	acb->firm_sdram_size=CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[3]);    /*firm_sdram_size, 3, 12-15*/
-	acb->firm_ide_channels=CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[4]);  /*firm_ide_channels, 4, 16-19*/
-	acb->firm_cfg_version=CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25,	  */
+	kprintf("Areca RAID adapter%d: %s F/W version %s \n", acb->pci_unit, acb->firm_model, acb->firm_version);
+	acb->firm_request_len = CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[1]);   /*firm_request_len, 1, 04-07*/
+	acb->firm_numbers_queue = CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[2]); /*firm_numbers_queue, 2, 08-11*/
+	acb->firm_sdram_size = CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[3]);    /*firm_sdram_size, 3, 12-15*/
+	acb->firm_ide_channels = CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[4]);  /*firm_ide_channels, 4, 16-19*/
+	acb->firm_cfg_version = CHIP_REG_READ32(HBB_RWBUFFER, 1, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25, 	  */
+	if(acb->firm_numbers_queue > ARCMSR_MAX_HBB_POSTQUEUE)
+		acb->maxOutstanding = ARCMSR_MAX_HBB_POSTQUEUE - 1;
+	else
+		acb->maxOutstanding = acb->firm_numbers_queue - 1;
 }
 /*
 **********************************************************************
@@ -2954,11 +3412,11 @@ static void arcmsr_get_hbb_config(struct AdapterControlBlock *acb)
 */
 static void arcmsr_get_hbc_config(struct AdapterControlBlock *acb)
 {
-	char *acb_firm_model=acb->firm_model;
-	char *acb_firm_version=acb->firm_version;
+	char *acb_firm_model = acb->firm_model;
+	char *acb_firm_version = acb->firm_version;
 	char *acb_device_map = acb->device_map;
-	size_t iop_firm_model=offsetof(struct HBC_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);   /*firm_model,15,60-67*/
-	size_t iop_firm_version=offsetof(struct HBC_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]); /*firm_version,17,68-83*/
+	size_t iop_firm_model = offsetof(struct HBC_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);   /*firm_model,15,60-67*/
+	size_t iop_firm_version = offsetof(struct HBC_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]); /*firm_version,17,68-83*/
 	size_t iop_device_map = offsetof(struct HBC_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
 	int i;
 
@@ -2967,33 +3425,87 @@ static void arcmsr_get_hbc_config(struct AdapterControlBlock *acb)
 	if(!arcmsr_hbc_wait_msgint_ready(acb)) {
 		kprintf("arcmsr%d: wait 'get adapter firmware miscellaneous data' timeout \n", acb->pci_unit);
 	}
-	i=0;
-	while(i<8) {
-		*acb_firm_model=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_model+i);
+	i = 0;
+	while(i < 8) {
+		*acb_firm_model = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_model+i); 
 		/* 8 bytes firm_model, 15, 60-67*/
 		acb_firm_model++;
 		i++;
 	}
-	i=0;
-	while(i<16) {
-		*acb_firm_version=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_version+i);
+	i = 0;
+	while(i < 16) {
+		*acb_firm_version = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_version+i);  
 		/* 16 bytes firm_version, 17, 68-83*/
 		acb_firm_version++;
 		i++;
 	}
-	i=0;
-	while(i<16) {
-		*acb_device_map=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_device_map+i);
+	i = 0;
+	while(i < 16) {
+		*acb_device_map = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_device_map+i);  
+		acb_device_map++;
+		i++;
+	}
+	kprintf("Areca RAID adapter%d: %s F/W version %s \n", acb->pci_unit, acb->firm_model, acb->firm_version);
+	acb->firm_request_len	= CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[1]);	/*firm_request_len,   1, 04-07*/
+	acb->firm_numbers_queue	= CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[2]);	/*firm_numbers_queue, 2, 08-11*/
+	acb->firm_sdram_size	= CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[3]);	/*firm_sdram_size,    3, 12-15*/
+	acb->firm_ide_channels	= CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[4]);	/*firm_ide_channels,  4, 16-19*/
+	acb->firm_cfg_version	= CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25, 	  */
+	if(acb->firm_numbers_queue > ARCMSR_MAX_OUTSTANDING_CMD)
+		acb->maxOutstanding = ARCMSR_MAX_OUTSTANDING_CMD - 1;
+	else
+		acb->maxOutstanding = acb->firm_numbers_queue - 1;
+}
+/*
+**********************************************************************
+**********************************************************************
+*/
+static void arcmsr_get_hbd_config(struct AdapterControlBlock *acb)
+{
+	char *acb_firm_model = acb->firm_model;
+	char *acb_firm_version = acb->firm_version;
+	char *acb_device_map = acb->device_map;
+	size_t iop_firm_model = offsetof(struct HBD_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);   /*firm_model,15,60-67*/
+	size_t iop_firm_version = offsetof(struct HBD_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]); /*firm_version,17,68-83*/
+	size_t iop_device_map = offsetof(struct HBD_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
+	int i;
+	
+	if(CHIP_REG_READ32(HBD_MessageUnit, 0, outbound_doorbell) & ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE)
+		CHIP_REG_WRITE32(HBD_MessageUnit, 0, outbound_doorbell, ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE_CLEAR);
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_GET_CONFIG);
+	if(!arcmsr_hbd_wait_msgint_ready(acb)) {
+		kprintf("arcmsr%d: wait 'get adapter firmware miscellaneous data' timeout \n", acb->pci_unit);
+	}
+	i = 0;
+	while(i < 8) {
+		*acb_firm_model = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_model+i); 
+		/* 8 bytes firm_model, 15, 60-67*/
+		acb_firm_model++;
+		i++;
+	}
+	i = 0;
+	while(i < 16) {
+		*acb_firm_version = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_version+i);  
+		/* 16 bytes firm_version, 17, 68-83*/
+		acb_firm_version++;
+		i++;
+	}
+	i = 0;
+	while(i < 16) {
+		*acb_device_map = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_device_map+i);  
 		acb_device_map++;
 		i++;
 	}
-	kprintf("ARECA RAID ADAPTER%d: %s \n", acb->pci_unit, ARCMSR_DRIVER_VERSION);
-	kprintf("ARECA RAID ADAPTER%d: FIRMWARE VERSION %s \n", acb->pci_unit, acb->firm_version);
-	acb->firm_request_len	=CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[1]);	/*firm_request_len,   1, 04-07*/
-	acb->firm_numbers_queue	=CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[2]);	/*firm_numbers_queue, 2, 08-11*/
-	acb->firm_sdram_size	=CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[3]);	/*firm_sdram_size,    3, 12-15*/
-	acb->firm_ide_channels	=CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[4]);	/*firm_ide_channels,  4, 16-19*/
-	acb->firm_cfg_version	=CHIP_REG_READ32(HBC_MessageUnit, 0, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25,	  */
+	kprintf("Areca RAID adapter%d: %s F/W version %s \n", acb->pci_unit, acb->firm_model, acb->firm_version);
+	acb->firm_request_len	= CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[2]);	/*firm_request_len,   1, 04-07*/
+	acb->firm_numbers_queue	= CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[3]);	/*firm_numbers_queue, 2, 08-11*/
+	acb->firm_sdram_size	= CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[4]);	/*firm_sdram_size,    3, 12-15*/
+	acb->firm_ide_channels	= CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[5]);	/*firm_ide_channels,  4, 16-19*/
+	acb->firm_cfg_version	= CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25, 	  */
+	if(acb->firm_numbers_queue > ARCMSR_MAX_HBD_POSTQUEUE)
+		acb->maxOutstanding = ARCMSR_MAX_HBD_POSTQUEUE - 1;
+	else
+		acb->maxOutstanding = acb->firm_numbers_queue - 1;
 }
 /*
 **********************************************************************
@@ -3014,6 +3526,10 @@ static void arcmsr_get_firmware_spec(struct AdapterControlBlock *acb)
 			arcmsr_get_hbc_config(acb);
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			arcmsr_get_hbd_config(acb);
+		}
+		break;
 	}
 }
 /*
@@ -3062,6 +3578,18 @@ static void arcmsr_wait_firmware_ready( struct AdapterControlBlock *acb)
 			}
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			while ((CHIP_REG_READ32(HBD_MessageUnit, 0, outbound_msgaddr1) & ARCMSR_HBDMU_MESSAGE_FIRMWARE_OK) == 0)
+			{
+				if (timeout++ > 2000) /* (2000*15)/1000 = 30 sec */
+				{
+					kprintf( "arcmsr%d:timed out waiting for firmware ready\n", acb->pci_unit);
+					return;
+				}
+				UDELAY(15000); /* wait 15 milli-seconds */
+			}
+		}
+		break;
 	}
 }
 /*
@@ -3092,6 +3620,15 @@ static void arcmsr_clear_doorbell_queue_buffer( struct AdapterControlBlock *acb)
 			outbound_doorbell = CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_doorbell);
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, outbound_doorbell_clear, outbound_doorbell);	/*clear doorbell interrupt */
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell, ARCMSR_HBCMU_DRV2IOP_DATA_READ_OK);
+			CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_doorbell_clear); /* Dummy read to force pci flush */
+			CHIP_REG_READ32(HBC_MessageUnit, 0, inbound_doorbell); /* Dummy read to force pci flush */
+		}
+		break;
+	case ACB_ADAPTER_TYPE_D: {
+			/* empty doorbell Qbuffer if door bell ringed */
+			outbound_doorbell = CHIP_REG_READ32(HBD_MessageUnit, 0, outbound_doorbell);
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, outbound_doorbell, outbound_doorbell);	/*clear doorbell interrupt */
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_doorbell, ARCMSR_HBDMU_DRV2IOP_DATA_OUT_READ);
 
 		}
 		break;
@@ -3105,6 +3642,7 @@ static u_int32_t arcmsr_iop_confirm(struct AdapterControlBlock *acb)
 {
 	unsigned long srb_phyaddr;
 	u_int32_t srb_phyaddr_hi32;
+	u_int32_t srb_phyaddr_lo32;
 
 	/*
 	********************************************************************
@@ -3112,12 +3650,12 @@ static u_int32_t arcmsr_iop_confirm(struct AdapterControlBlock *acb)
 	** if freesrb.HighPart is not zero
 	********************************************************************
 	*/
-	srb_phyaddr= (unsigned long) acb->srb_phyaddr.phyaddr;
-//	srb_phyaddr_hi32=(u_int32_t) ((srb_phyaddr>>16)>>16);
-	srb_phyaddr_hi32=acb->srb_phyaddr.B.phyadd_high;
+	srb_phyaddr = (unsigned long) acb->srb_phyaddr.phyaddr;
+	srb_phyaddr_hi32 = acb->srb_phyaddr.B.phyadd_high;
+	srb_phyaddr_lo32 = acb->srb_phyaddr.B.phyadd_low;
 	switch (acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
-			if(srb_phyaddr_hi32!=0) {
+			if(srb_phyaddr_hi32 != 0) {
 				CHIP_REG_WRITE32(HBA_MessageUnit, 0, msgcode_rwbuffer[0], ARCMSR_SIGNATURE_SET_CONFIG);
 				CHIP_REG_WRITE32(HBA_MessageUnit, 0, msgcode_rwbuffer[1], srb_phyaddr_hi32);
 				CHIP_REG_WRITE32(HBA_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_SET_CONFIG);
@@ -3137,9 +3675,9 @@ static u_int32_t arcmsr_iop_confirm(struct AdapterControlBlock *acb)
 			u_int32_t post_queue_phyaddr;
 			struct HBB_MessageUnit *phbbmu;
 
-			phbbmu=(struct HBB_MessageUnit *)acb->pmu;
-			phbbmu->postq_index=0;
-			phbbmu->doneq_index=0;
+			phbbmu = (struct HBB_MessageUnit *)acb->pmu;
+			phbbmu->postq_index = 0;
+			phbbmu->doneq_index = 0;
 			CHIP_REG_WRITE32(HBB_DOORBELL, 0, drv2iop_doorbell, ARCMSR_MESSAGE_SET_POST_WINDOW);
 			if(!arcmsr_hbb_wait_msgint_ready(acb)) {
 				kprintf( "arcmsr%d: 'set window of post command Q' timeout\n", acb->pci_unit);
@@ -3165,7 +3703,7 @@ static u_int32_t arcmsr_iop_confirm(struct AdapterControlBlock *acb)
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
-			if(srb_phyaddr_hi32!=0) {
+			if(srb_phyaddr_hi32 != 0) {
 				CHIP_REG_WRITE32(HBC_MessageUnit, 0, msgcode_rwbuffer[0], ARCMSR_SIGNATURE_SET_CONFIG);
 				CHIP_REG_WRITE32(HBC_MessageUnit, 0, msgcode_rwbuffer[1], srb_phyaddr_hi32);
 				CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_SET_CONFIG);
@@ -3177,6 +3715,29 @@ static u_int32_t arcmsr_iop_confirm(struct AdapterControlBlock *acb)
 			}
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			u_int32_t post_queue_phyaddr, done_queue_phyaddr;
+			struct HBD_MessageUnit0 *phbdmu;
+	
+			phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+			phbdmu->postq_index = 0;
+			phbdmu->doneq_index = 0x40FF;
+			post_queue_phyaddr = srb_phyaddr_lo32 + ARCMSR_SRBS_POOL_SIZE 
+								+ offsetof(struct HBD_MessageUnit0, post_qbuffer);
+			done_queue_phyaddr = srb_phyaddr_lo32 + ARCMSR_SRBS_POOL_SIZE 
+								+ offsetof(struct HBD_MessageUnit0, done_qbuffer);
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, msgcode_rwbuffer[0], ARCMSR_SIGNATURE_SET_CONFIG); /* driver "set config" signature */
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, msgcode_rwbuffer[1], srb_phyaddr_hi32);
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, msgcode_rwbuffer[2], post_queue_phyaddr); /* postQ base */
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, msgcode_rwbuffer[3], done_queue_phyaddr); /* doneQ base */
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, msgcode_rwbuffer[4], 0x100);
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_SET_CONFIG);
+			if(!arcmsr_hbd_wait_msgint_ready(acb)) {
+				kprintf( "arcmsr%d: 'set srb high part physical address' timeout \n", acb->pci_unit);
+				return FALSE;
+			}
+		}
+		break;
 	}
 	return (TRUE);
 }
@@ -3190,12 +3751,12 @@ static void arcmsr_enable_eoi_mode(struct AdapterControlBlock *acb)
 	{
 	case ACB_ADAPTER_TYPE_A:
 	case ACB_ADAPTER_TYPE_C:
+	case ACB_ADAPTER_TYPE_D:
 		break;
 	case ACB_ADAPTER_TYPE_B: {
 			CHIP_REG_WRITE32(HBB_DOORBELL, 0, drv2iop_doorbell,ARCMSR_MESSAGE_ACTIVE_EOI_MODE);
 			if(!arcmsr_hbb_wait_msgint_ready(acb)) {
 				kprintf( "arcmsr%d: 'iop enable eoi mode' timeout \n", acb->pci_unit);
-
 				return;
 			}
 		}
@@ -3211,7 +3772,7 @@ static void arcmsr_iop_init(struct AdapterControlBlock *acb)
 	u_int32_t intmask_org;
 
 	/* disable all outbound interrupt */
-	intmask_org=arcmsr_disable_allintr(acb);
+	intmask_org = arcmsr_disable_allintr(acb);
 	arcmsr_wait_firmware_ready(acb);
 	arcmsr_iop_confirm(acb);
 	arcmsr_get_firmware_spec(acb);
@@ -3222,7 +3783,7 @@ static void arcmsr_iop_init(struct AdapterControlBlock *acb)
 	arcmsr_enable_eoi_mode(acb);
 	/* enable outbound Post Queue, outbound doorbell Interrupt */
 	arcmsr_enable_allintr(acb, intmask_org);
-	acb->acb_flags |=ACB_F_IOP_INITED;
+	acb->acb_flags |= ACB_F_IOP_INITED;
 }
 /*
 **********************************************************************
@@ -3230,35 +3791,37 @@ static void arcmsr_iop_init(struct AdapterControlBlock *acb)
 */
 static void arcmsr_map_free_srb(void *arg, bus_dma_segment_t *segs, int nseg, int error)
 {
-	struct AdapterControlBlock *acb=arg;
+	struct AdapterControlBlock *acb = arg;
 	struct CommandControlBlock *srb_tmp;
-	u_int8_t * dma_memptr;
 	u_int32_t i;
-	unsigned long srb_phyaddr=(unsigned long)segs->ds_addr;
+	unsigned long srb_phyaddr = (unsigned long)segs->ds_addr;
 
-	dma_memptr=acb->uncacheptr;
-	acb->srb_phyaddr.phyaddr=srb_phyaddr;
-	srb_tmp=(struct CommandControlBlock *)dma_memptr;
-	for(i=0;i<ARCMSR_MAX_FREESRB_NUM;i++) {
+	acb->srb_phyaddr.phyaddr = srb_phyaddr; 
+	srb_tmp = (struct CommandControlBlock *)acb->uncacheptr;
+	for(i=0; i < ARCMSR_MAX_FREESRB_NUM; i++) {
 		if(bus_dmamap_create(acb->dm_segs_dmat,
-			 /*flags*/0, &srb_tmp->dm_segs_dmamap)!=0) {
+			 /*flags*/0, &srb_tmp->dm_segs_dmamap) != 0) {
 			acb->acb_flags |= ACB_F_MAPFREESRB_FAILD;
 			kprintf("arcmsr%d:"
 			" srb dmamap bus_dmamap_create error\n", acb->pci_unit);
 			return;
 		}
-		srb_tmp->cdb_shifted_phyaddr=(acb->adapter_type==ACB_ADAPTER_TYPE_C)?srb_phyaddr:(srb_phyaddr >> 5);
-		srb_tmp->acb=acb;
-		acb->srbworkingQ[i]=acb->psrb_pool[i]=srb_tmp;
-		srb_phyaddr=srb_phyaddr+SRB_SIZE;
-		srb_tmp = (struct CommandControlBlock *)((unsigned long)srb_tmp+SRB_SIZE);
+		if((acb->adapter_type == ACB_ADAPTER_TYPE_C) || (acb->adapter_type == ACB_ADAPTER_TYPE_D))
+		{
+			srb_tmp->cdb_phyaddr_low = srb_phyaddr;
+			srb_tmp->cdb_phyaddr_high = (u_int32_t)((srb_phyaddr >> 16) >> 16);
+		}
+		else
+			srb_tmp->cdb_phyaddr_low = srb_phyaddr >> 5;
+		srb_tmp->acb = acb;
+		acb->srbworkingQ[i] = acb->psrb_pool[i] = srb_tmp;
+		srb_phyaddr = srb_phyaddr + SRB_SIZE;
+		srb_tmp = (struct CommandControlBlock *)((unsigned long)srb_tmp + SRB_SIZE);
 	}
-	acb->vir2phy_offset=(unsigned long)srb_tmp-srb_phyaddr;
+	acb->vir2phy_offset = (unsigned long)srb_tmp - (unsigned long)srb_phyaddr;
 }
 /*
 ************************************************************************
-**
-**
 ************************************************************************
 */
 static void arcmsr_free_resource(struct AdapterControlBlock *acb)
@@ -3277,30 +3840,62 @@ static void arcmsr_free_resource(struct AdapterControlBlock *acb)
 ************************************************************************
 ************************************************************************
 */
+static void arcmsr_mutex_init(struct AdapterControlBlock *acb)
+{
+	ARCMSR_LOCK_INIT(&acb->isr_lock, "arcmsr isr lock");
+	ARCMSR_LOCK_INIT(&acb->srb_lock, "arcmsr srb lock");
+	ARCMSR_LOCK_INIT(&acb->postDone_lock, "arcmsr postQ lock");
+	ARCMSR_LOCK_INIT(&acb->qbuffer_lock, "arcmsr RW buffer lock");
+}
+/*
+************************************************************************
+************************************************************************
+*/
+static void arcmsr_mutex_destroy(struct AdapterControlBlock *acb)
+{
+	ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+	ARCMSR_LOCK_DESTROY(&acb->postDone_lock);
+	ARCMSR_LOCK_DESTROY(&acb->srb_lock);
+	ARCMSR_LOCK_DESTROY(&acb->isr_lock);
+}
+/*
+************************************************************************
+************************************************************************
+*/
 static u_int32_t arcmsr_initialize(device_t dev)
 {
-	struct AdapterControlBlock *acb=device_get_softc(dev);
+	struct AdapterControlBlock *acb = device_get_softc(dev);
 	u_int16_t pci_command;
 	int i, j,max_coherent_size;
 	u_int32_t vendor_dev_id;
 
 	vendor_dev_id = pci_get_devid(dev);
 	acb->vendor_device_id = vendor_dev_id;
+	acb->sub_device_id = pci_read_config(dev, PCIR_SUBDEV_0, 2);
 	switch (vendor_dev_id) {
 	case PCIDevVenIDARC1880:
 	case PCIDevVenIDARC1882:
 	case PCIDevVenIDARC1213:
 	case PCIDevVenIDARC1223: {
-			acb->adapter_type=ACB_ADAPTER_TYPE_C;
+			acb->adapter_type = ACB_ADAPTER_TYPE_C;
+			if (acb->sub_device_id == ARECA_SUB_DEV_ID_1883)
+				acb->adapter_bus_speed = ACB_BUS_SPEED_12G;
+			else
+				acb->adapter_bus_speed = ACB_BUS_SPEED_6G;
+			max_coherent_size = ARCMSR_SRBS_POOL_SIZE;
+		}
+		break;
+	case PCIDevVenIDARC1214: {
+			acb->adapter_type = ACB_ADAPTER_TYPE_D;
 			acb->adapter_bus_speed = ACB_BUS_SPEED_6G;
-			max_coherent_size=ARCMSR_SRBS_POOL_SIZE;
+			max_coherent_size = ARCMSR_SRBS_POOL_SIZE + (sizeof(struct HBD_MessageUnit0));
 		}
 		break;
 	case PCIDevVenIDARC1200:
 	case PCIDevVenIDARC1201: {
-			acb->adapter_type=ACB_ADAPTER_TYPE_B;
+			acb->adapter_type = ACB_ADAPTER_TYPE_B;
 			acb->adapter_bus_speed = ACB_BUS_SPEED_3G;
-			max_coherent_size=ARCMSR_SRBS_POOL_SIZE+(sizeof(struct HBB_MessageUnit));
+			max_coherent_size = ARCMSR_SRBS_POOL_SIZE + (sizeof(struct HBB_MessageUnit));
 		}
 		break;
 	case PCIDevVenIDARC1110:
@@ -3322,9 +3917,9 @@ static u_int32_t arcmsr_initialize(device_t dev)
 	case PCIDevVenIDARC1381:
 	case PCIDevVenIDARC1680:
 	case PCIDevVenIDARC1681: {
-			acb->adapter_type=ACB_ADAPTER_TYPE_A;
+			acb->adapter_type = ACB_ADAPTER_TYPE_A;
 			acb->adapter_bus_speed = ACB_BUS_SPEED_3G;
-			max_coherent_size=ARCMSR_SRBS_POOL_SIZE;
+			max_coherent_size = ARCMSR_SRBS_POOL_SIZE;
 		}
 		break;
 	default: {
@@ -3333,7 +3928,7 @@ static u_int32_t arcmsr_initialize(device_t dev)
 			return ENOMEM;
 		}
 	}
-	if(bus_dma_tag_create(  /*parent*/	NULL,
+	if(bus_dma_tag_create(  /*PCI parent*/		bus_get_dma_tag(dev),
 				/*alignemnt*/	1,
 				/*boundary*/	0,
 				/*lowaddr*/	BUS_SPACE_MAXADDR,
@@ -3367,6 +3962,7 @@ static u_int32_t arcmsr_initialize(device_t dev)
 		kprintf("arcmsr%d: dm_segs_dmat bus_dma_tag_create failure!\n", device_get_unit(dev));
 		return ENOMEM;
 	}
+
 	/* DMA tag for our srb structures.... Allocate the freesrb memory */
 	if(bus_dma_tag_create(  /*parent_dmat*/	acb->parent_dmat,
 				/*alignment*/	0x20,
@@ -3402,19 +3998,18 @@ static u_int32_t arcmsr_initialize(device_t dev)
 		kprintf("arcmsr%d: srb_dmat bus_dmamap_load failure!\n", device_get_unit(dev));
 		return ENXIO;
 	}
-	pci_command=pci_read_config(dev, PCIR_COMMAND, 2);
+	pci_command = pci_read_config(dev, PCIR_COMMAND, 2);
 	pci_command |= PCIM_CMD_BUSMASTEREN;
 	pci_command |= PCIM_CMD_PERRESPEN;
 	pci_command |= PCIM_CMD_MWRICEN;
-	/* Enable Busmaster/Mem */
-	pci_command |= PCIM_CMD_MEMEN;
+	/* Enable Busmaster */
 	pci_write_config(dev, PCIR_COMMAND, pci_command, 2);
 	switch(acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
-			u_int32_t rid0=PCIR_BAR(0);
+			u_int32_t rid0 = PCIR_BAR(0);
 			vm_offset_t	mem_base0;
 
-			acb->sys_res_arcmsr[0]=bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, 0x1000, RF_ACTIVE);
+			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, 0x1000, RF_ACTIVE);
 			if(acb->sys_res_arcmsr[0] == NULL) {
 				arcmsr_free_resource(acb);
 				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
@@ -3425,15 +4020,15 @@ static u_int32_t arcmsr_initialize(device_t dev)
 				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
 				return ENXIO;
 			}
-			mem_base0=(vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
-			if(mem_base0==0) {
+			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+			if(mem_base0 == 0) {
 				arcmsr_free_resource(acb);
 				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
 				return ENXIO;
 			}
-			acb->btag[0]=rman_get_bustag(acb->sys_res_arcmsr[0]);
-			acb->bhandle[0]=rman_get_bushandle(acb->sys_res_arcmsr[0]);
-			acb->pmu=(struct MessageUnit_UNION *)mem_base0;
+			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+			acb->pmu = (struct MessageUnit_UNION *)mem_base0;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_B: {
@@ -3441,12 +4036,12 @@ static u_int32_t arcmsr_initialize(device_t dev)
 			struct CommandControlBlock *freesrb;
 			u_int32_t rid[]={ PCIR_BAR(0), PCIR_BAR(2) };
 			vm_offset_t	mem_base[]={0,0};
-			for(i=0; i<2; i++) {
-				if(i==0) {
-					acb->sys_res_arcmsr[i]=bus_alloc_resource(dev,SYS_RES_MEMORY, &rid[i],
+			for(i=0; i < 2; i++) {
+				if(i == 0) {
+					acb->sys_res_arcmsr[i] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid[i],
 											0ul, ~0ul, sizeof(struct HBB_DOORBELL), RF_ACTIVE);
 				} else {
-					acb->sys_res_arcmsr[i]=bus_alloc_resource(dev, SYS_RES_MEMORY, &rid[i],
+					acb->sys_res_arcmsr[i] = bus_alloc_resource(dev, SYS_RES_MEMORY, &rid[i],
 											0ul, ~0ul, sizeof(struct HBB_RWBUFFER), RF_ACTIVE);
 				}
 				if(acb->sys_res_arcmsr[i] == NULL) {
@@ -3459,28 +4054,54 @@ static u_int32_t arcmsr_initialize(device_t dev)
 					kprintf("arcmsr%d: rman_get_start %d failure!\n", device_get_unit(dev), i);
 					return ENXIO;
 				}
-				mem_base[i]=(vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[i]);
-				if(mem_base[i]==0) {
+				mem_base[i] = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[i]);
+				if(mem_base[i] == 0) {
 					arcmsr_free_resource(acb);
 					kprintf("arcmsr%d: rman_get_virtual %d failure!\n", device_get_unit(dev), i);
 					return ENXIO;
 				}
-				acb->btag[i]=rman_get_bustag(acb->sys_res_arcmsr[i]);
-				acb->bhandle[i]=rman_get_bushandle(acb->sys_res_arcmsr[i]);
+				acb->btag[i] = rman_get_bustag(acb->sys_res_arcmsr[i]);
+				acb->bhandle[i] = rman_get_bushandle(acb->sys_res_arcmsr[i]);
 			}
-			freesrb=(struct CommandControlBlock *)acb->uncacheptr;
-//			acb->pmu=(struct MessageUnit_UNION *)&freesrb[ARCMSR_MAX_FREESRB_NUM];
-			acb->pmu=(struct MessageUnit_UNION *)((unsigned long)freesrb+ARCMSR_SRBS_POOL_SIZE);
-			phbbmu=(struct HBB_MessageUnit *)acb->pmu;
-			phbbmu->hbb_doorbell=(struct HBB_DOORBELL *)mem_base[0];
-			phbbmu->hbb_rwbuffer=(struct HBB_RWBUFFER *)mem_base[1];
+			freesrb = (struct CommandControlBlock *)acb->uncacheptr;
+			acb->pmu = (struct MessageUnit_UNION *)((unsigned long)freesrb+ARCMSR_SRBS_POOL_SIZE);
+			phbbmu = (struct HBB_MessageUnit *)acb->pmu;
+			phbbmu->hbb_doorbell = (struct HBB_DOORBELL *)mem_base[0];
+			phbbmu->hbb_rwbuffer = (struct HBB_RWBUFFER *)mem_base[1];
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
-			u_int32_t rid0=PCIR_BAR(1);
+			u_int32_t rid0 = PCIR_BAR(1);
+			vm_offset_t	mem_base0;
+
+			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBC_MessageUnit), RF_ACTIVE);
+			if(acb->sys_res_arcmsr[0] == NULL) {
+				arcmsr_free_resource(acb);
+				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+				return ENOMEM;
+			}
+			if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+				arcmsr_free_resource(acb);
+				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+				return ENXIO;
+			}
+			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+			if(mem_base0 == 0) {
+				arcmsr_free_resource(acb);
+				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+				return ENXIO;
+			}
+			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+			acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+		}
+		break;
+	case ACB_ADAPTER_TYPE_D: {
+			struct HBD_MessageUnit0 *phbdmu;
+			u_int32_t rid0 = PCIR_BAR(0);
 			vm_offset_t	mem_base0;
 
-			acb->sys_res_arcmsr[0]=bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBC_MessageUnit), RF_ACTIVE);
+			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBD_MessageUnit), RF_ACTIVE);
 			if(acb->sys_res_arcmsr[0] == NULL) {
 				arcmsr_free_resource(acb);
 				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
@@ -3491,15 +4112,17 @@ static u_int32_t arcmsr_initialize(device_t dev)
 				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
 				return ENXIO;
 			}
-			mem_base0=(vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
-			if(mem_base0==0) {
+			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+			if(mem_base0 == 0) {
 				arcmsr_free_resource(acb);
 				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
 				return ENXIO;
 			}
-			acb->btag[0]=rman_get_bustag(acb->sys_res_arcmsr[0]);
-			acb->bhandle[0]=rman_get_bushandle(acb->sys_res_arcmsr[0]);
-			acb->pmu=(struct MessageUnit_UNION *)mem_base0;
+			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+			acb->pmu = (struct MessageUnit_UNION *)((unsigned long)acb->uncacheptr+ARCMSR_SRBS_POOL_SIZE);
+			phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+			phbdmu->phbdmu = (struct HBD_MessageUnit *)mem_base0;
 		}
 		break;
 	}
@@ -3515,9 +4138,9 @@ static u_int32_t arcmsr_initialize(device_t dev)
 	** init raid volume state
 	********************************************************************
 	*/
-	for(i=0;i<ARCMSR_MAX_TARGETID;i++) {
-		for(j=0;j<ARCMSR_MAX_TARGETLUN;j++) {
-			acb->devstate[i][j]=ARECA_RAID_GONE;
+	for(i=0; i < ARCMSR_MAX_TARGETID; i++) {
+		for(j=0; j < ARCMSR_MAX_TARGETLUN; j++) {
+			acb->devstate[i][j] = ARECA_RAID_GONE;
 		}
 	}
 	arcmsr_iop_init(acb);
@@ -3541,63 +4164,63 @@ static int arcmsr_attach(device_t dev)
 		kprintf("arcmsr%d: cannot allocate softc\n", unit);
 		return (ENOMEM);
 	}
-	ARCMSR_LOCK_INIT(&acb->qbuffer_lock, "arcmsr Q buffer lock");
+	arcmsr_mutex_init(acb);
+	acb->pci_dev = dev;
+	acb->pci_unit = unit;
 	if(arcmsr_initialize(dev)) {
 		kprintf("arcmsr%d: initialize failure!\n", unit);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		return ENXIO;
 	}
 	/* After setting up the adapter, map our interrupt */
 	rid=0;
 	acb->irq_type = pci_alloc_1intr(dev, arcmsr_msi_enable, &rid,
 	    &irq_flags);
-	irqres=bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0ul, ~0ul, 1,
+	irqres = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0ul, ~0ul, 1,
 	    irq_flags);
 	if(irqres == NULL ||
 		bus_setup_intr(dev, irqres, INTR_MPSAFE, arcmsr_intr_handler, acb, &acb->ih, NULL)) {
 		arcmsr_free_resource(acb);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: unable to register interrupt handler!\n", unit);
 		return ENXIO;
 	}
-	acb->irqres=irqres;
-	acb->pci_dev=dev;
-	acb->pci_unit=unit;
+	acb->irqres = irqres;
 	/*
 	 * Now let the CAM generic SCSI layer find the SCSI devices on
 	 * the bus *  start queue to reset to the idle loop. *
 	 * Create device queue of SIM(s) *  (MAX_START_JOB - 1) :
 	 * max_sim_transactions
 	*/
-	devq=cam_simq_alloc(ARCMSR_MAX_START_JOB);
+	devq = cam_simq_alloc(acb->maxOutstanding);
 	if(devq == NULL) {
 	    arcmsr_free_resource(acb);
 		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
 		if (acb->irq_type == PCI_INTR_TYPE_MSI)
 			pci_release_msi(dev);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: cam_simq_alloc failure!\n", unit);
 		return ENXIO;
 	}
-	acb->psim=cam_sim_alloc(arcmsr_action, arcmsr_poll, "arcmsr", acb, unit, &acb->qbuffer_lock, 1, ARCMSR_MAX_OUTSTANDING_CMD, devq);
+	acb->psim = cam_sim_alloc(arcmsr_action, arcmsr_poll, "arcmsr", acb, unit, &acb->isr_lock, 1, ARCMSR_MAX_OUTSTANDING_CMD, devq);
 	cam_simq_release(devq);
 	if(acb->psim == NULL) {
 		arcmsr_free_resource(acb);
 		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
 		if (acb->irq_type == PCI_INTR_TYPE_MSI)
 			pci_release_msi(dev);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: cam_sim_alloc failure!\n", unit);
 		return ENXIO;
 	}
-	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	if(xpt_bus_register(acb->psim, 0) != CAM_SUCCESS) {
 		arcmsr_free_resource(acb);
 		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
 		if (acb->irq_type == PCI_INTR_TYPE_MSI)
 			pci_release_msi(dev);
 		cam_sim_free(acb->psim);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: xpt_bus_register failure!\n", unit);
 		return ENXIO;
 	}
